Works

List Works (POST)

POST
/works.list

Lists a collection of work items.

Required scopes: Depends on the object type in the type field:

typerequired scope
incidentincident:read OR incident:write OR incident:all
issueissue:read OR issue:write OR issue:all
opportunityopportunity:read OR opportunity:write OR opportunity:all
tasktask:read OR task:write OR task:all
ticketticket:read OR ticket:write OR ticket:all

Authorization

auth-token
AuthorizationBearer <token>

All the DevRev APIs require a token to authenticate the user. Provide Authorization: Bearer <TOKEN> as a header to every API request. How do I find my token?

In: header

Request Body

application/json

type?array<work-type>

Filters for work of the provided types.

actual_close_date?|

Provides ways to specify date ranges on objects.

applies_to_part?array<string>

Filters for work belonging to any of the provided parts.

created_by?array<string>

Filters for work created by any of these users.

created_date?|

Provides ways to specify date ranges on objects.

cursor?string

The cursor to resume iteration from. If not provided, then iteration starts from the beginning.

Formattext
custom_fields?object

Filters for custom fields.

external_ref?array<string>

Filters for work with any of the provided external references.

issue?
limit?integer

The maximum number of works to return. The default is '50'.

Formatint32
mode?string

The iteration mode to use. If "after", then entries after the provided cursor will be returned, or if no cursor is provided, then from the beginning. If "before", then entries before the provided cursor will be returned, or if no cursor is provided, then from the end. Entries will always be returned in the specified sort-by order.

Value in"after" | "before"
modified_by?array<string>

Filters for work modified by any of these users.

modified_date?|

Provides ways to specify date ranges on objects.

opportunity?
owned_by?array<string>

Filters for work owned by any of these users.

reported_by?array<string>

Filters for work reported by any of these users.

sort_by?array<string>

Fields to sort the works by and the direction to sort them.

stage?

The filter for stages.

staged_info?
state?array<string>

Filters for work with any of the provided states.

sync_metadata?
tags?array<string>

Filters for work with any of the provided tags.

target_close_date?|

Provides ways to specify date ranges on objects.

ticket?
vista?string

Filters for work belonging to the given vista.

Formatid

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://api.devrev.ai/works.list" \  -H "Content-Type: application/json" \  -d '{}'
{
  "next_cursor": "string",
  "prev_cursor": "string",
  "works": [
    {
      "type": "issue",
      "created_by": {
        "type": "dev_user",
        "display_id": "string",
        "id": "string",
        "display_name": "string",
        "display_picture": {
          "display_id": "string",
          "id": "string",
          "file": {
            "type": "string",
            "name": "string",
            "size": 0
          }
        },
        "email": "string",
        "full_name": "string",
        "state": "active"
      },
      "created_date": "2023-01-01T12:00:00.000Z",
      "display_id": "string",
      "id": "string",
      "modified_by": {
        "type": "dev_user",
        "display_id": "string",
        "id": "string",
        "display_name": "string",
        "display_picture": {
          "display_id": "string",
          "id": "string",
          "file": {
            "type": "string",
            "name": "string",
            "size": 0
          }
        },
        "email": "string",
        "full_name": "string",
        "state": "active"
      },
      "modified_date": "2023-01-01T12:00:00.000Z",
      "object_version": 0,
      "actual_close_date": "2023-01-01T12:00:00.000Z",
      "applies_to_part": {
        "type": "capability",
        "display_id": "string",
        "id": "string",
        "name": "string",
        "owned_by": [
          {
            "type": "dev_user",
            "display_id": "string",
            "id": "string",
            "display_name": "string",
            "display_picture": {
              "display_id": "string",
              "id": "string",
              "file": {
                "type": "string",
                "name": "string",
                "size": 0
              }
            },
            "email": "string",
            "full_name": "string",
            "state": "active"
          }
        ],
        "sync_metadata": {
          "external_reference": "string",
          "last_sync_in": {
            "status": "failed",
            "sync_unit": {
              "display_id": "string",
              "id": "string",
              "external_sync_unit_name": "string",
              "external_system_id": "string",
              "external_system_name": "string",
              "external_system_type": "adaas",
              "is_archived": true,
              "name": "string",
              "sync_run": {
                "mode": "initial",
                "progress": {
                  "state": "completed"
                },
                "reserved_rate_limit_percentage": 0
              },
              "sync_type": "manual"
            }
          },
          "origin_system": "string"
        }
      },
      "artifacts": [
        {
          "display_id": "string",
          "id": "string",
          "file": {
            "type": "string",
            "name": "string",
            "size": 0
          }
        }
      ],
      "body": "string",
      "custom_fields": {},
      "custom_schema_fragments": [
        "don:core:dvrv-us-1:devo/example:custom_type_fragment/custom-type-fragment-id"
      ],
      "external_ref": "string",
      "owned_by": [
        {
          "type": "dev_user",
          "display_id": "string",
          "id": "string",
          "display_name": "string",
          "display_picture": {
            "display_id": "string",
            "id": "string",
            "file": {
              "type": "string",
              "name": "string",
              "size": 0
            }
          },
          "email": "string",
          "full_name": "string",
          "state": "active"
        }
      ],
      "reported_by": [
        {
          "type": "dev_user",
          "display_id": "string",
          "id": "string",
          "display_name": "string",
          "display_picture": {
            "display_id": "string",
            "id": "string",
            "file": {
              "type": "string",
              "name": "string",
              "size": 0
            }
          },
          "email": "string",
          "full_name": "string",
          "state": "active"
        }
      ],
      "stage": {
        "name": "string",
        "notes": "string",
        "ordinal": 0,
        "stage": {
          "display_id": "string",
          "id": "string",
          "name": "string",
          "sync_metadata": {
            "external_reference": "string",
            "last_sync_in": {
              "status": "failed",
              "sync_unit": {
                "display_id": "string",
                "id": "string",
                "external_sync_unit_name": "string",
                "external_system_id": "string",
                "external_system_name": "string",
                "external_system_type": "adaas",
                "is_archived": true,
                "name": "string",
                "sync_run": {
                  "mode": "initial",
                  "progress": {
                    "state": "completed"
                  },
                  "reserved_rate_limit_percentage": 0
                },
                "sync_type": "manual"
              }
            },
            "origin_system": "string"
          }
        },
        "state": {
          "display_id": "string",
          "id": "string",
          "is_final": true,
          "name": "string",
          "sync_metadata": {
            "external_reference": "string",
            "last_sync_in": {
              "status": "failed",
              "sync_unit": {
                "display_id": "string",
                "id": "string",
                "external_sync_unit_name": "string",
                "external_system_id": "string",
                "external_system_name": "string",
                "external_system_type": "adaas",
                "is_archived": true,
                "name": "string",
                "sync_run": {
                  "mode": "initial",
                  "progress": {
                    "state": "completed"
                  },
                  "reserved_rate_limit_percentage": 0
                },
                "sync_type": "manual"
              }
            },
            "origin_system": "string"
          }
        }
      },
      "state_display_name": "string",
      "stock_schema_fragment": "don:core:dvrv-us-1:devo/example:custom_type_fragment/custom-type-fragment-id",
      "subtype": "string",
      "sync_metadata": {
        "external_record_id": "string",
        "external_record_type": "string",
        "external_reference": "string",
        "last_sync_in": {
          "status": "failed",
          "sync_date": "2023-01-01T12:00:00.000Z",
          "sync_unit": {
            "display_id": "string",
            "id": "string",
            "external_sync_unit_name": "string",
            "external_system_id": "string",
            "external_system_name": "string",
            "external_system_type": "adaas",
            "is_archived": true,
            "name": "string",
            "sync_run": {
              "mode": "initial",
              "progress": {
                "state": "completed"
              },
              "reserved_rate_limit_percentage": 0
            },
            "sync_type": "manual"
          }
        },
        "last_sync_out": {
          "status": "failed",
          "sync_date": "2023-01-01T12:00:00.000Z",
          "sync_unit": {
            "display_id": "string",
            "id": "string",
            "external_sync_unit_name": "string",
            "external_system_id": "string",
            "external_system_name": "string",
            "external_system_type": "adaas",
            "is_archived": true,
            "name": "string",
            "sync_run": {
              "mode": "initial",
              "progress": {
                "state": "completed"
              },
              "reserved_rate_limit_percentage": 0
            },
            "sync_type": "manual"
          }
        },
        "origin_system": "string"
      },
      "tags": [
        {
          "tag": {
            "display_id": "string",
            "id": "string",
            "name": "string",
            "style_new": {
              "color": "string"
            },
            "sync_metadata": {
              "external_reference": "string",
              "last_sync_in": {
                "status": "failed",
                "sync_unit": {
                  "display_id": "string",
                  "id": "string",
                  "external_sync_unit_name": "string",
                  "external_system_id": "string",
                  "external_system_name": "string",
                  "external_system_type": "adaas",
                  "is_archived": true,
                  "name": "string",
                  "sync_run": {
                    "mode": "initial",
                    "progress": {
                      "state": "completed"
                    },
                    "reserved_rate_limit_percentage": 0
                  },
                  "sync_type": "manual"
                }
              },
              "origin_system": "string"
            }
          },
          "value": "string"
        }
      ],
      "target_close_date": "2023-01-01T12:00:00.000Z",
      "title": "string",
      "actual_start_date": "2023-01-01T12:00:00.000Z",
      "developed_with": [
        {
          "type": "capability",
          "display_id": "string",
          "id": "string",
          "name": "string",
          "owned_by": [
            {
              "type": "dev_user",
              "display_id": "string",
              "id": "string",
              "display_name": "string",
              "display_picture": {
                "display_id": "string",
                "id": "string",
                "file": {
                  "type": "string",
                  "name": "string",
                  "size": 0
                }
              },
              "email": "string",
              "full_name": "string",
              "state": "active"
            }
          ],
          "sync_metadata": {
            "external_reference": "string",
            "last_sync_in": {
              "status": "failed",
              "sync_unit": {
                "display_id": "string",
                "id": "string",
                "external_sync_unit_name": "string",
                "external_system_id": "string",
                "external_system_name": "string",
                "external_system_type": "adaas",
                "is_archived": true,
                "name": "string",
                "sync_run": {
                  "mode": "initial",
                  "progress": {
                    "state": "completed"
                  },
                  "reserved_rate_limit_percentage": 0
                },
                "sync_type": "manual"
              }
            },
            "origin_system": "string"
          }
        }
      ],
      "display_id_alias": "string",
      "estimated_effort": 0.1,
      "last_code_activity": "2023-01-01T12:00:00.000Z",
      "priority": "p0",
      "priority_v2": {
        "color": "string",
        "id": 0,
        "label": "string",
        "ordinal": 0,
        "value": null
      },
      "sla_summary": {
        "closest_to_breach_metric": "string",
        "org_schedule": {
          "display_id": "string",
          "id": "string",
          "name": "string",
          "status": "archived",
          "timezone": "string",
          "valid_until": "2023-01-01T12:00:00.000Z",
          "version_number": 0
        },
        "remaining_time": 0,
        "sla_tracker": {
          "created_by": {
            "type": "dev_user",
            "display_id": "string",
            "id": "string",
            "display_name": "string",
            "display_picture": {
              "display_id": "string",
              "id": "string",
              "file": {
                "type": "string",
                "name": "string",
                "size": 0
              }
            },
            "email": "string",
            "full_name": "string",
            "state": "active"
          },
          "created_date": "2023-01-01T12:00:00.000Z",
          "display_id": "string",
          "id": "string",
          "modified_by": {
            "type": "dev_user",
            "display_id": "string",
            "id": "string",
            "display_name": "string",
            "display_picture": {
              "display_id": "string",
              "id": "string",
              "file": {
                "type": "string",
                "name": "string",
                "size": 0
              }
            },
            "email": "string",
            "full_name": "string",
            "state": "active"
          },
          "modified_date": "2023-01-01T12:00:00.000Z",
          "object_version": 0,
          "applies_to_id": "string",
          "applies_to_type": "conversation",
          "metric_target_summaries": [
            {
              "breached_at": "2023-01-01T12:00:00.000Z",
              "completed_at": "2023-01-01T12:00:00.000Z",
              "completed_in": 0,
              "completed_in_seconds": 0,
              "in_policy": true,
              "is_out_of_schedule": true,
              "metric_definition": {
                "display_id": "string",
                "id": "string",
                "name": "string"
              },
              "next_schedule_transition": "2023-01-01T12:00:00.000Z",
              "org_schedule": {
                "display_id": "string",
                "id": "string",
                "name": "string",
                "status": "archived",
                "timezone": "string",
                "valid_until": "2023-01-01T12:00:00.000Z",
                "version_number": 0
              },
              "org_schedule_version": 0,
              "remaining_time": 0,
              "stage": "string",
              "status": "string",
              "target_time": "2023-01-01T12:00:00.000Z",
              "warning_target_time": "2023-01-01T12:00:00.000Z"
            }
          ],
          "removed_sla_metric_history": [
            {
              "metric_definition": {
                "display_id": "string",
                "id": "string",
                "name": "string"
              },
              "removed_at": "2023-01-01T12:00:00.000Z",
              "removed_by": {
                "type": "dev_user",
                "display_id": "string",
                "id": "string",
                "display_name": "string",
                "display_picture": {
                  "display_id": "string",
                  "id": "string",
                  "file": {
                    "type": "string",
                    "name": "string",
                    "size": 0
                  }
                },
                "email": "string",
                "full_name": "string",
                "state": "active"
              }
            }
          ],
          "sla": {
            "display_id": "string",
            "id": "string",
            "name": "string",
            "sla_type": "external",
            "status": "archived"
          },
          "sla_policy_id": "string",
          "stage": "string",
          "status": "string"
        },
        "stage": "breached",
        "target_time": "2023-01-01T12:00:00.000Z"
      },
      "sla_tracker": {
        "display_id": "string",
        "id": "string",
        "applies_to_type": "conversation"
      },
      "space": "string",
      "sprint": {
        "type": "curated",
        "end_date": "2023-01-01T12:00:00.000Z",
        "id": "string",
        "name": "string",
        "start_date": "2023-01-01T12:00:00.000Z",
        "state": "active"
      },
      "target_start_date": "2023-01-01T12:00:00.000Z"
    }
  ]
}
{
  "detail": "string",
  "message": "string",
  "type": "artifact_already_attached_to_a_parent",
  "existing_parent": "string",
  "is_same": true
}
{
  "detail": "string",
  "message": "string",
  "type": "dev_org_deactivated"
}
{
  "detail": "string",
  "message": "string",
  "type": "forbidden",
  "object_ids": [
    "string"
  ]
}
{
  "detail": "string",
  "message": "string",
  "type": "request_entity_too_large",
  "max_bytes": 0
}
{
  "detail": "string",
  "message": "string",
  "type": "too_many_requests",
  "retry_after": 0
}
{
  "detail": "string",
  "message": "string",
  "type": "internal_error",
  "reference_id": "string"
}
{
  "detail": "string",
  "message": "string",
  "type": "service_unavailable"
}